<?php
// $Id: simpletestauto.inc,v 1.3.2.7 2006/08/31 11:03:11 rokZlender Exp $
function simpletestauto_test_insert($node) {
  if ($node->file) {
    $file = file_save_upload($node->file, file_directory_path());
    $node->patch_url = file_create_url($file->filepath);
  }
  db_query("INSERT INTO {simpletestauto_test} (nid, project, patch_url, version, tested, file_path, file_mime, file_size) VALUES (%d, '%s', '%s', '%s', '%d', '%s', '%s', '%d')", $node->nid, $node->project, $node->patch_url,$node->version, $node->tested, $file->filepath, $file->filemime, $file->filesize);
}

function simpletestauto_test_update($node) {
  db_query("UPDATE {simpletestauto_test} SET project = '%s', patch_url = '%s', version = '%s', tested = '%d' WHERE nid = %d", $node->project, $node->patch_url, $node->version, $node->tested, $node->nid);
}

function simpletestauto_test_load($node) {
  $test = db_fetch_object(db_query('SELECT * FROM {simpletestauto_test} WHERE nid = %d', $node->nid));
  return $test;
}

function simpletestauto_test_delete($node) {
  db_query('DELETE FROM {simpletestauto_test} WHERE nid = %d', $node->nid);
}

function simpletestauto_test_form(&$node) {
  $form['#attributes'] = array("enctype" => "multipart/form-data");
  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#required' => TRUE,
    '#default_value' => $node->title,
    '#weight' => -5
  );
 $form['body_filter']['body'] = array(
    '#type' => 'textarea',
    '#description' => 'You can leave this empty or write some notes about your patch.',
    '#title' => t('Body'),
    '#default_value' => $node->body,
    '#required' => FALSE
  );
  $form['body_filter']['filter'] = filter_form($node->format);

  $form['project'] = array(
    '#type' => 'textfield',
    '#title' => t('Project name'),
    '#description' => t('Which project is this patch for. If project is drupal core than write Drupal'),
    '#default_value' => $node->project,
    '#required' => TRUE,
  );
  
  $versions['HEAD'] = 'Head';
  $versions['4.7'] = 'Drupal 4.7';
  $form['version'] = array(
    '#type' => 'select',
    '#title' => t('Version'),
    '#default_value' => (isset($node->version) ? $node->version : '4.7') ,
    '#options' => $versions,
    '#required' => TRUE,
  );
  
  $form['patch_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Patch URL'),
    '#default_value' => $node->patch_url,
    '#description' => "Enter patch url here or upload patch.",
  );
  if (!isset($node->patch_url)) {
  	$form['patch_file'] = array(
      '#type' => 'file',
      '#title' => t('File attachment'),
      '#size' => 40,
      '#description' => ($node->patch_file || $node->patch_file ? t('A file already exists, if you upload another file the current file will be replaced.') : t('Attach a patch.')),
    );
  }

  return $form;
}

function simpletestauto_test_node_form_validate($form_id, $form) {
  global $form_values;
  $edit = $_POST['edit'];
  $file = file_check_upload('patch_file');
  if ($form_values['patch_url'] == "" && $file == NULL) {
    form_set_error('patch_url', t('Please provide a patch url or upload a new file.'));
  }
  $form_values['file'] = file_save_upload($file);
}

/**
 * Implementation of hook_content().
 */
function simpletestauto_test_content($node, $teaser = false) {
  return node_prepare($node, $teaser);
}

/**
 * Retunrs all patches that are not tested
 * @return array of node ids of untested patches
 */
function get_untested_patches() {
  $result = db_query("SELECT nid FROM {simpletestauto_test} WHERE tested = 0");
  $nodes = array();
  while($patch = db_fetch_object($result)) {
  	$nodes[] = $patch->nid;
  }
  return $nodes;
}

function simpletestauto_test_view(&$node, $teaser = false, $page = false) {
  if (!$teaser && $page) {
    $test = node_load($node->nid);

    $output = '<div class="project">';
    $rows = array();
    $rows[] = array('Project: ', check_plain($test->project));
    $rows[] = array('Version: ', check_plain($test->version));
    $rows[] = array(t('Patch url: '),  l($node->patch_url, $node->patch_url));
    switch ($node->tested) {
      case SIMPLETESTAUTO_PASS:
        $status = t('PASSED');
        break;
      case SIMPLETESTAUTO_FAIL:
        $status = t('FAILED');
        break;
      case SIMPLETESTAUTO_NOT_TESTED:
        $status = t('NOT TESTED');
        break;
      case SIMPLETESTAUTO_SUBMITED:
        $status = t('SUBMITED TO TEST SERVER');
        break;
      case SIMPLETESTAUTO_IN_PROGRESS:
        $status = t('TESTING IN PROGRESS');
        break;    
    }
    $rows[] = array(t('Status: '), $status);
    $output .= '<div class="summary">'. theme('table', array(), $rows) .'</div>';
    
    $output .= '<p>'. $node->body .'</p>';
    if ($node->tested == SIMPLETESTAUTO_NOT_TESTED) {
      $time_to_next_run = 60 - date('i');
      $output .= '<p>'. t('Your patch will be tested in approximately %min minutes', array('%min' => $time_to_next_run)) .'</p>';
    }
    $output .= '</div>';

    $node->body = $output;
  }
}

function simpletestauto_test_access($op, $node) {
  global $user;
  if ($op == 'create') {
    return user_access('create simpletestauto_test');
  }
  
  if ($op == 'update' || $op == 'delete') {
  	if (user_access('edit own simpletestauto_test')  && ($user->uid == $node->uid)) {
  	  return TRUE;
  	}
  }
}
?>
